module Dugong
	class DataSet

		def self.get_development(id)
			get_raw(id, "localhost:3000")
		end

		def self.get(id)
			get_raw(id, "dugong.herokuapp.com")
		end

		def self.get_raw(id, root)
			require 'json'
			require 'rest-client'
			require 'open-uri'
			require 'csv'

			url = "http://#{root}/data_sets/#{id}.json?info=true"
			res = RestClient.get url
			json = JSON.parse(res)

			file_url = json["url"]
			file_type = json["file_type"]
			col_sep = get_delimiter(file_type)

			io = open(file_url)
			file = CSV.parse(io, {:col_sep => col_sep})
			return file
		end

		def self.get_delimiter(file_type)
	        if file_type == "csv"
	            return ","
	        elsif file_type == "txt"
	            return " "
	        elsif file_type == "tab"
	            return "\t"
	        else
	            return nil
	        end
	    end

	end
end